function love.load()
	BC = { -- The Background Colour
		r = 64,
		g = 96,
		b = 208,
	}
	love.graphics.setBackgroundColor(BC.r, BC.g, BC.b)
	
	width, height = love.window.getDesktopDimensions( 1 )
	screen = {
		x = width,
		y = height,
	}
	success = love.window.setMode(screen.x, screen.y, {fullscreen=true})
	
	squares = {}
	squarePossibleStats = {
		maxSize = 75,
		minSize = 30,
		maxTime = 100,
		minTime = 40,
		maxnextSquareTime = 250,
		minnextSquareTime = 60,
	}
	nextSquareTime = 100
	
	highScore = 0
	currentScore = 0
	
	font = love.graphics.newFont(20)
	love.graphics.setFont(font)
end

function newSquare()
	local size = love.math.random(squarePossibleStats.minSize, squarePossibleStats.maxSize)
	local timeToClick = love.math.random(squarePossibleStats.minTime, squarePossibleStats.maxTime)
	local newX = love.math.random(0,screen.x-(size + 2*timeToClick))
	local newY = love.math.random(0,screen.y-(size + 2*timeToClick))
	NewSquare = {}
		NewSquare.origionalTimeLeft = timeToClick
		NewSquare.timeLeft = timeToClick
		NewSquare.innerSize = size --the inside square
		NewSquare.outerSize = size + 2*timeToClick
		NewSquare.outerX = newX-timeToClick
		NewSquare.outerY = newY-timeToClick
		NewSquare.innerX = newX
		NewSquare.innerY = newY
		NewSquare.r = love.math.random(0,255)
		NewSquare.g = 0
		NewSquare.b = 0
		table.insert(squares, NewSquare)
end

function love.update(dt)
	nextSquareTime = nextSquareTime - 1
	if nextSquareTime < 1 then
		local newSquareMin = squarePossibleStats.minnextSquareTime
		local newSquareMax = squarePossibleStats.maxnextSquareTime
		if newSquareMax-currentScore*7>newSquareMin+30 then
			newSquareMax = newSquareMax - currentScore*7
		end
		nextSquareTime = love.math.random(newSquareMin, newSquareMax)
		newSquare()
	end
	
	for i,v in ipairs(squares) do
		v.timeLeft = v.timeLeft - 1
		v.outerX = v.outerX + 1
		v.outerY = v.outerY + 1
		v.outerSize = v.outerSize - 2
		if v.timeLeft < 1 then
			MouseX, MouseY = love.mouse.getPosition( )
			if (MouseX > v.innerX and MouseX < v.innerX+v.innerSize) and (MouseY > v.innerY and MouseY < v.innerY+v.innerSize) then
				currentScore = currentScore + 1
				if currentScore > highScore then
					highScore = currentScore
				end
			else
				currentScore = 0
				squares = {}
			end
			table.remove(squares, i)
		end
	end
end

function love.draw()
	for i,v in ipairs(squares) do
		love.graphics.setColor(v.r, v.g, v.b)
		love.graphics.rectangle("line", v.outerX, v.outerY, v.outerSize, v.outerSize) --outer square
		love.graphics.setColor(0, 0, 0)
		love.graphics.rectangle("fill", v.innerX, v.innerY, v.innerSize, v.innerSize) --inner square
	end
	love.graphics.setColor(255-BC.r, 255-BC.g, 255-BC.b)
	love.graphics.print("Current Score: "..currentScore.." HighScore: "..highScore, 5, 5)
end